def fib3(n):
    fib_list = [0] * (n + 1) # nが小さいときの結果をメモするためのリスト
    fib_list[1] = 1          # 初期値 a_1 = 1 (a_0 = 0 は初期化時に代入済)

    # 2番目からn番目の値を順番に求めていく
    for i in range(2,n+1):
        fib_list[i] = fib_list[i-1] + fib_list[i-2]

    return fib_list[n] # 結果 a_n

print(fib3( 50)) # 12586269025
print(fib3(100)) # 354224848179261915075
